Access control in React File Manager component

18 Nov 201810 minutes to read

The React File Manager allows you to define access permissions for folders and files using a set of access rules to user(s).

Access Rules

The FileAccessController allows you to define security permissions for folders and files using a set of folder or file access rules.

To set up access rules for folders (including their files and sub-folders) and individual files, use the SetRules() method in the controller. The following table represents the AccessRule properties available for file and folder:

Properties Applicable for file Applicable for folder Description
Copy Yes Yes Allows access to copy a file or folder.
Read Yes Yes Allows access to read a file or folder.
Write Yes Yes Allows permission to write a file or folder.
WriteContents No Yes Allows permission to write the content of folder.
Download Yes Yes Allows permission to download a file or folder.
Upload No Yes Allows permission to upload to the folder.
Path Yes Yes Specifies the path to apply the rules, which are defined.
Role Yes Yes Specifies the role to which the rule is applied.
IsFile Yes Yes Specifies whether the rule is specified for folder or file.

The following syntax represents the access Rules for Administrator using file or folder.

//Adminstrator
//Access Rules for File
    new AccessRule { Path = "/*.*", Role = "Administrator", Read = Permission.Allow, Write = Permission.Allow, Copy = Permission.Allow, Download = Permission.Allow, IsFile = true },

// Access Rules for folder
   new AccessRule { Path = "*", Role = "Administrator", Read = Permission.Allow, Write = Permission.Allow, Copy = Permission.Allow, WriteContents = Permission.Allow, Upload = Permission.Allow, Download = Permission.Deny, IsFile = false },

The following syntax represent the access Rules for Default user using file or folder.

//Default User
//Access Rules for File
    new AccessRule { Path = "/*.*", Role = "Default User", Read = Permission.Deny, Write = Permission.Deny, Copy = Permission.Deny, Download = Permission.Deny, IsFile = true },

// Access Rules for folder
     new AccessRule { Path = "*", Role = "Default User", Read = Permission.Deny, Write = Permission.Deny, Copy = Permission.Deny, WriteContents = Permission.Deny, Upload = Permission.Deny, Download = Permission.Deny, IsFile = false },

Permissions

It helps to explain how to apply security permission to File Manager file or folder using access rules. The following table represent the value that determines the permission.

Value Description
Allow Allows you to do read, write, copy, and download operations.
Deny Denies you to do read, write, copy, and download operations.

Use the Role property to apply created roles to the File Manager. After that, the File Manager displays folder or file and allow permisssion based on assigned roles.

The following syntax represent how to apply permission based on assigned roles

Permission denied for administrator to write a file or folder.

// For file
 new AccessRule { Path = "/*.*", Role = "Administrator", Read = Permission.Allow, Write = Permission.Deny, IsFile = true},

// For folder
  new AccessRule { Path = "*", Role = "Administrator", Read = Permission.Allow, Write = Permission.Deny, IsFile = false},

The following syntax represent how to allow or deny permission based on file or folder access rule.

Permission denied for writing except for particular file or folder.

// Deny writing for particular folder
 new AccessRule { Path = "/Documents", Role = "Document Manager", Read = Permission.Allow, Write = Permission.Deny, Copy = Permission.Allow, WriteContents = Permission.Deny, Upload = Permission.Deny, Download = Permission.Deny, IsFile = false },

 // Deny writing for particular file
  new AccessRule { Path = "/Pictures/Employees/Adam.png", Role = "Document Manager", Read = Permission.Allow, Write = Permission.Deny, Copy = Permission.Deny, Download = Permission.Deny, IsFile = true },

Permission denied for writing and uploading in root folder.

// Folder Rule
 new AccessRule { Path = "/", Role = "Document Manager", Read = Permission.Allow, Write = Permission.Deny, Copy = Permission.Deny, WriteContents = Permission.Deny, Upload = Permission.Deny, Download = Permission.Deny, IsFile = false },

The following example demonstrate the File Manager rendered with access control support.

import { DetailsView, FileManagerComponent, Inject, NavigationPane, Toolbar } from '@syncfusion/ej2-react-filemanager';
import * as React from 'react';
function App() {
    let fileObj;
    let hostUrl = "https://physical-service.syncfusion.com/";
    let ajaxSettings = {
        downloadUrl: hostUrl + 'api/FileManagerAccess/Download',
        getImageUrl: hostUrl + 'api/FileManagerAccess/GetImage',
        uploadUrl: hostUrl + 'api/FileManagerAccess/Upload',
        url: hostUrl + 'api/FileManagerAccess/FileOperations'
    };
    let view = "Details";
    let height = "375px";
    return (<div>
      <div className="control-section">
          <FileManagerComponent ref={s => (fileObj = s)} id="file" ajaxSettings={ajaxSettings} view={view} height={height} >
              <Inject services={[NavigationPane, DetailsView, Toolbar]}/>
          </FileManagerComponent>
      </div>
  </div>);
}
export default App;
import {  DetailsView, FileManagerComponent, Inject, NavigationPane, Toolbar} from '@syncfusion/ej2-react-filemanager';
import * as React from 'react';

function App() {
  let fileObj: FileManagerComponent;
  let hostUrl: string = "https://physical-service.syncfusion.com/";
  let ajaxSettings: object = {
    downloadUrl: hostUrl + 'api/FileManagerAccess/Download',
    getImageUrl: hostUrl + 'api/FileManagerAccess/GetImage',
    uploadUrl: hostUrl + 'api/FileManagerAccess/Upload',
    url: hostUrl + 'api/FileManagerAccess/FileOperations'
  };
  let view: string = "Details";
  let height: string = "375px";

  return (
    <div>
      <div className="control-section">
        <FileManagerComponent ref={s => (fileObj = s as FileManagerComponent)} id="file"
          ajaxSettings={ajaxSettings} view={view} height={height} >
          <Inject services={[NavigationPane, DetailsView, Toolbar]} />
        </FileManagerComponent>
      </div>
    </div>
  );
}
export default App;
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import App from './App';
ReactDOM.render(<App />, document.getElementById('root'));
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import App from './App';

ReactDOM.render( <App />, document.getElementById('root') as HTMLElement);

Access control in Vue File Manager component

18 Nov 20189 minutes to read

The Vue File Manager component enables defining access permissions for folders and files by configuring a set of access rules per user or role.

Access Rules

The FileAccessController lets you define security permissions for folders and files using folder- or file-level access rules.

Use the SetRules() method to set access rules for folders (including their files and subfolders) and for individual files. The following table lists the properties available on an AccessRule and indicates whether each property applies to files and/or folders:

Properties Applicable for file Applicable for folder Description
Copy Yes Yes Allows copying the file or folder.
Read Yes Yes Allows reading the file or folder.
Write Yes Yes Allows writing to the file or folder.
WriteContents No Yes Allows modifying the contents of a folder.
Download Yes Yes Allows downloading the file or folder.
Upload No Yes Allows uploading into the folder.
Path Yes Yes Specifies the path where the rule applies.
Role Yes Yes Specifies the role to which the rule applies.
IsFile Yes Yes Indicates whether the rule targets a file (true) or a folder (false).

The following example shows access rules for an Administrator role:

// Administrator
// Access Rules for files
new AccessRule { Path = "/*.*", Role = "Administrator", Read = Permission.Allow, Write = Permission.Allow, Copy = Permission.Allow, Download = Permission.Allow, IsFile = true },

// Access Rules for folders
new AccessRule { Path = "*", Role = "Administrator", Read = Permission.Allow, Write = Permission.Allow, Copy = Permission.Allow, WriteContents = Permission.Allow, Upload = Permission.Allow, Download = Permission.Deny, IsFile = false },

The following example shows access rules for a Default User role:

// Default User
// Access Rules for files
new AccessRule { Path = "/*.*", Role = "Default User", Read = Permission.Deny, Write = Permission.Deny, Copy = Permission.Deny, Download = Permission.Deny, IsFile = true },

// Access Rules for folders
new AccessRule { Path = "*", Role = "Default User", Read = Permission.Deny, Write = Permission.Deny, Copy = Permission.Deny, WriteContents = Permission.Deny, Upload = Permission.Deny, Download = Permission.Deny, IsFile = false },

Permissions

This section explains how access rules determine permissions for files and folders in the File Manager. The table below summarizes the possible permission values.

Value Description
Allow Grants permission to perform the specified operations (read, write, copy, download).
Deny Denies permission to perform the specified operations (read, write, copy, download).

Apply access rules by using the Role property to target specific roles. The File Manager then displays and permits operations on files and folders based on the assigned roles and rules.

The following example demonstrates denying write permission for the Administrator role:

// For file
new AccessRule { Path = "/*.*", Role = "Administrator", Read = Permission.Allow, Write = Permission.Deny, IsFile = true },

// For folder
new AccessRule { Path = "*", Role = "Administrator", Read = Permission.Allow, Write = Permission.Deny, IsFile = false },

The following examples show how to deny write permission except for particular files or folders.

// Deny writing for a specific folder
new AccessRule { Path = "/Documents", Role = "Document Manager", Read = Permission.Allow, Write = Permission.Deny, Copy = Permission.Allow, WriteContents = Permission.Deny, Upload = Permission.Deny, Download = Permission.Deny, IsFile = false },

// Deny writing for a specific file
new AccessRule { Path = "/Pictures/Employees/Adam.png", Role = "Document Manager", Read = Permission.Allow, Write = Permission.Deny, Copy = Permission.Deny, Download = Permission.Deny, IsFile = true },

Example: deny writing and uploading in the root folder:

// Folder rule
new AccessRule { Path = "/", Role = "Document Manager", Read = Permission.Allow, Write = Permission.Deny, Copy = Permission.Deny, WriteContents = Permission.Deny, Upload = Permission.Deny, Download = Permission.Deny, IsFile = false },

The following example demonstrates the File Manager rendered with access control support.

<template>
    <div id="app">
        <ejs-filemanager id="file-manager"  :ajaxSettings="ajaxSettings">
        </ejs-filemanager>
    </div>
</template>
<script setup>
import { provide } from "vue";

import { FileManagerComponent as EjsFilemanager, DetailsView, NavigationPane, Toolbar } from "@syncfusion/ej2-vue-filemanager";

const ajaxSettings =
{
    url: "https://physical-service.syncfusion.com/api/FileManagerAccess/FileOperations",
    getImageUrl: "https://physical-service.syncfusion.com/api/FileManagerAccess/GetImage",
    uploadUrl: "https://physical-service.syncfusion.com/api/FileManagerAccess/Upload",
    downloadUrl: "https://physical-service.syncfusion.com/api/FileManagerAccess/Download"
};
provide('filemanager',  [DetailsView, NavigationPane, Toolbar]);

</script>
<style>
    @import "../node_modules/@syncfusion/ej2-material3-theme/styles/file-manager/index.css";
</style>
<template>
    <div id="app">
        <ejs-filemanager id="file-manager"  :ajaxSettings="ajaxSettings">
        </ejs-filemanager>
    </div>
</template>
<script>

import { FileManagerComponent, DetailsView, NavigationPane, Toolbar } from "@syncfusion/ej2-vue-filemanager";

export default {
    name: "App",
    components: {
        "ejs-filemanager":FileManagerComponent,
    },
    data () {
        return {
             ajaxSettings:
            {
                url: "https://physical-service.syncfusion.com/api/FileManagerAccess/FileOperations",
                getImageUrl: "https://physical-service.syncfusion.com/api/FileManagerAccess/GetImage",
                uploadUrl: "https://physical-service.syncfusion.com/api/FileManagerAccess/Upload",
                downloadUrl: "https://physical-service.syncfusion.com/api/FileManagerAccess/Download"
            },
        };
    },
    provide: {
            filemanager: [DetailsView, NavigationPane, Toolbar]
    }
}
</script>
<style>
    @import "../node_modules/@syncfusion/ej2-material3-theme/styles/file-manager/index.css";
</style>

Access control in Angular File Manager component

18 Nov 20189 minutes to read

Access control in the File Manager allows you to restrict user actions by defining permissions for files and folders. This security feature lets you control who can read, write, download, upload, or copy specific content based on user roles.

Access Rules

Access rules define the security permissions for folders and files in the File Manager. The FileAccessController class provides the foundation for implementing these rules in your application.

To set up access rules for folders (including their files and sub-folders) and individual files, use the SetRules() method in the controller. The rules determine which operations are allowed for specific paths and user roles.

The following table represents the AccessRule properties available for files and folders:

Properties Applicable for file Applicable for folder Description
Copy Yes Yes Allows access to copy a file or folder.
Read Yes Yes Allows access to read a file or folder.
Write Yes Yes Allows permission to write a file or folder.
WriteContents No Yes Allows permission to write the content of folder.
Download Yes Yes Allows permission to download a file or folder.
Upload No Yes Allows permission to upload to the folder.
Path Yes Yes Specifies the path to apply the rules, which are defined.
Role Yes Yes Specifies the role to which the rule is applied.
IsFile Yes Yes Specifies whether the rule is specified for folder or file.

The following example represents the access rules for an Administrator role:

// Administrator
// Access Rules for File
new AccessRule { Path = "/*.*", Role = "Administrator", Read = Permission.Allow, Write = Permission.Allow, 
Copy = Permission.Allow, Download = Permission.Allow, IsFile = true },

// Access Rules for folder
new AccessRule { Path = "*", Role = "Administrator", Read = Permission.Allow, Write = Permission.Allow, 
Copy = Permission.Allow, WriteContents = Permission.Allow, Upload = Permission.Allow, Download = Permission.Deny, 
IsFile = false },

The following example represents the access rules for a Default user role:

// Default User
// Access Rules for File
new AccessRule { Path = "/*.*", Role = "Default User", Read = Permission.Deny, Write = Permission.Deny, 
Copy = Permission.Deny, Download = Permission.Deny, IsFile = true },

// Access Rules for folder
new AccessRule { Path = "*", Role = "Default User", Read = Permission.Deny, Write = Permission.Deny, 
Copy = Permission.Deny, WriteContents = Permission.Deny, Upload = Permission.Deny, Download = Permission.Deny, IsFile = false },

Permissions

This section explains how to apply security permissions to File Manager files or folders using access rules. The File Manager uses two permission values:

Value Description
Allow Allows you to do read, write, copy, and download operations.
Deny Denies you to do read, write, copy, and download operations.

Use the Role property to apply created roles to the File Manager. After assigning roles, the File Manager displays folders or files and allows operations based on the permissions defined for each role.

Examples of Permission Rules

Denying write permission for administrator

// For file
new AccessRule { Path = "/*.*", Role = "Administrator", Read = Permission.Allow, Write = Permission.Deny, IsFile = true},

// For folder
new AccessRule { Path = "*", Role = "Administrator", Read = Permission.Allow, Write = Permission.Deny, IsFile = false},

Denying write permission for specific folders or files

// Deny writing for particular folder
new AccessRule { Path = "/Documents", Role = "Document Manager", Read = Permission.Allow, Write = Permission.Deny, 
Copy = Permission.Allow, WriteContents = Permission.Deny, Upload = Permission.Deny, Download = Permission.Deny, 
IsFile = false },

// Deny writing for particular file
new AccessRule { Path = "/Pictures/Employees/Adam.png", Role = "Document Manager", Read = Permission.Allow, 
Write = Permission.Deny, Copy = Permission.Deny, Download = Permission.Deny, IsFile = true },

Denying write and upload permissions for root folder

// Folder Rule
new AccessRule { Path = "/", Role = "Document Manager", Read = Permission.Allow, Write = Permission.Deny, 
Copy = Permission.Deny, WriteContents = Permission.Deny, Upload = Permission.Deny, Download = Permission.Deny, 
IsFile = false },

The following example demonstrates the File Manager rendered with access control support:

import { BrowserModule } from '@angular/platform-browser'
import { NgModule } from '@angular/core'
import { FileManagerModule, NavigationPaneService, ToolbarService, DetailsViewService } from '@syncfusion/ej2-angular-filemanager'
import { Component } from '@angular/core';

@Component({
    imports: [FileManagerModule,],
    providers: [NavigationPaneService, ToolbarService, DetailsViewService],
    standalone: true,
    selector: 'app-root',
    styleUrls: ['./app.component.css'],
    template: `<ejs-filemanager id='file-manager' [ajaxSettings]='ajaxSettings' [view]='view' height="375px">
    </ejs-filemanager>`
})
export class AppComponent {
    public ajaxSettings?: object | any;
    public view?: string;
    public hostUrl: string = 'https://physical-service.syncfusion.com/';
    public ngOnInit(): void {
        this.ajaxSettings = {
            url: this.hostUrl + 'api/FileManagerAccess/FileOperations',
            getImageUrl: this.hostUrl + 'api/FileManagerAccess/GetImage',
            uploadUrl: this.hostUrl + 'api/FileManagerAccess/Upload',
            downloadUrl: this.hostUrl + 'api/FileManagerAccess/Download'
        };
        this.view = "Details";
    }
}
@import "node_modules/@syncfusion/ej2-material3-theme/styles/file-manager/index.css";
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));